#include "poirot.h"
#include <stdio.h>

#define TRUE 1
#define FALSE 0

int x;
int y;
int z;
int balance;

int init;
int deposit_done;
int withdraw_done;

int start (void)
{
  x = poirot_nondet();
  y = poirot_nondet();
  z = poirot_nondet();
  
  POIROT_ATOMIC (balance = x)
  
  init = TRUE;
  
  return 0;
}


int deposit(void)
{
  __hv_assume(init);
  
  POIROT_ATOMIC (
    balance = balance + y;
    deposit_done = TRUE
  )
  
  return 0;
}


int withdraw(void)
{
  __hv_assume(init);
  
  POIROT_ATOMIC (
    balance = balance - z;
    withdraw_done = TRUE
  )
  
  return 0;
}


int check_result(void)
{
  __hv_assume(init);
  
  POIROT_ATOMIC(
    if (deposit_done && withdraw_done)
    {
      POIROT_ASSERT(balance == (x + y) - z); /* GOOD */
    }
  )
  
  return 0;
}


void main(void) {
  int th_1, th_2, th_3, th_4;
  
  init = FALSE;
  deposit_done = FALSE;
  withdraw_done = FALSE;
  
  __async_call th_1 = start();
  __async_call th_2 = deposit();
  __async_call th_3 = withdraw();
  __async_call th_4 = check_result();
}