#include "poirot.h"
#include <stdio.h>

#define TRUE 1
#define FALSE 0

int pendingIo;
int stopFlag;
int stopEvent;
int stopped;

int stopper(void) {
  int dec1_pio;
  stopFlag = TRUE;
  
  POIROT_ATOMIC (
    pendingIo = pendingIo - 1;
    dec1_pio = pendingIo;
  )
  
  if(dec1_pio==0)
  {
    stopEvent = TRUE;
  }
  
  __hv_assume(stopEvent);
  
  stopped = TRUE;
  
  return 0;
}

int adder1(void) {
  int inc1_status;
  int dec1_pio;
  int dec2_pio;
  int status;

  POIROT_ATOMIC (
    pendingIo = pendingIo + 1;
  )

  if(stopFlag)
  {
    POIROT_ATOMIC (
	  pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    )

    if(dec2_pio==0)
    {
      stopEvent = TRUE;
    }

    inc1_status = 0;
  }
  else
  {
    inc1_status = 1;
  }

  status = inc1_status;

  if(status>0)
  {
    POIROT_ASSERT(!stopped);
    /* Perform IO */
    POIROT_ATOMIC (
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
	)

    if(dec2_pio==0)
    {
      stopEvent = TRUE;
    }
  }
  
  return 0;
}

int adder2(void) {
  int inc1_status;
  int dec1_pio;
  int dec2_pio;
  int status;

  POIROT_ATOMIC (
    pendingIo = pendingIo + 1;
  )

  if(stopFlag)
  {
    POIROT_ATOMIC (
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    )

    if(dec2_pio==0)
    {
      stopEvent = TRUE;
    }

    inc1_status = 0;
  }
  else
  {
    inc1_status = 1;
  }

  status = inc1_status;

  if(status>0)
  {
    POIROT_ASSERT(!stopped);
    /* Perform IO */
    POIROT_ATOMIC (
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    )

    if(dec2_pio==0)
    {
      stopEvent = TRUE;
    }
  }
  
  return 0;
}

void main(void) {
  int th_1, th_2, th_3;
  
  pendingIo = 1;
  stopFlag = FALSE;
  stopEvent = FALSE;
  stopped = FALSE;
  
  __async_call th_1 = adder1();
  __async_call th_2 = adder2();
  __async_call th_3 = stopper();
}
