#include <pthread.h>

void __ESBMC_atomic_begin();
void __ESBMC_atomic_end();

int pendingIo = 1;
_Bool stopFlag = 0;
_Bool stopEvent = 0;
_Bool stopped = 0;

void * stopper(void * args) {
  int dec1_pio;
  stopFlag = 1;
  
  __ESBMC_atomic_begin();
    pendingIo=pendingIo - 1;
    dec1_pio = pendingIo;
  __ESBMC_atomic_end();
  
  if(dec1_pio==0)
  {
    stopEvent = 1;
  }
  
  __ESBMC_assume(stopEvent);
  
  stopped = 1;
}

void * adder1(void * args) {
  int inc1_status;
  int dec1_pio;
  int dec2_pio;
  int status;

  __ESBMC_atomic_begin();
    pendingIo = pendingIo + 1;
  __ESBMC_atomic_end();

  if(stopFlag)
  {
    __ESBMC_atomic_begin();
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    __ESBMC_atomic_end();

    if(dec2_pio==0)
    {
      stopEvent = 1;
    }

    inc1_status = 0;
  }
  else
  {
    inc1_status = 1;
  }

  status = inc1_status;

  if(status>0)
  {
    assert(!stopped);
    /* Perform IO */
    __ESBMC_atomic_begin();
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    __ESBMC_atomic_end();

    if(dec2_pio==0)
    {
      stopEvent = 1;
    }
  }
}

void * adder2(void * args) {
  int inc1_status;
  int dec1_pio;
  int dec2_pio;
  int status;

  __ESBMC_atomic_begin();
    pendingIo = pendingIo + 1;
  __ESBMC_atomic_end();

  if(stopFlag)
  {
    __ESBMC_atomic_begin();
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    __ESBMC_atomic_end();

    if(dec2_pio==0)
    {
      stopEvent = 1;
    }

    inc1_status = 0;
  }
  else
  {
    inc1_status = 1;
  }

  status = inc1_status;

  if(status>0)
  {
    assert(!stopped);
    /* Perform IO */
    __ESBMC_atomic_begin();
      pendingIo=pendingIo - 1;
      dec2_pio = pendingIo;
    __ESBMC_atomic_end();

    if(dec2_pio==0)
    {
      stopEvent = 1;
    }
  }
}

void main(void) {
  pthread_t th_1, th_2, th_3;
  
  pthread_create(&th_1, NULL, adder1, NULL);
  pthread_create(&th_2, NULL, adder2, NULL);
  pthread_create(&th_3, NULL, stopper, NULL);
}
