#!/bin/bash

echo "Running Esbmc on the concurrent examples:"

# Non-terminating runs commented out

# CORRECT EXAMPLES

#echo "  Account Good"
#(time esbmc account_good.cc.c --z3-ir --context-switch 10  ) > conc_esbmc_logs/account_good.log 2>&1
#echo "    .. Done"

#echo "  BigNum Good"
#(time esbmc bignum_good.cc.c --context-switch 234 --unwind 26) > conc_esbmc_logs/bignum_good.log 2>&1
#echo "    .. Done"

echo "  Bluetooth 3a"
(time esbmc bluetooth3a.cc.c --context-switch 28 ) > conc_esbmc_logs/bluetooth3a.log 2>&1
echo "    .. Done"

echo "  Token Ring"
(time esbmc tokenring_good.cc.c --context-switch 4) > conc_esbmc_logs/tokenring_good.log 2>&1
echo "    .. Done"

# BUGGY EXAMPLES

echo "  Account Bad"
(time esbmc account_bad.cc.c --context-switch 4 --z3-ir) > conc_esbmc_logs/account_bad.log 2>&1
echo "    .. Done"

#echo "  BigNum Bad"
# (time esbmc bignum_bad.cc.c --context-switch 26 --unwind 26) > conc_esbmc_logs/bignum_bad.log 2>&1
#echo "    .. Done"

echo "  Bluetooth1"
(time esbmc bluetooth1.cc.c --context-switch 5) > conc_esbmc_logs/bluetooth1.log 2>&1
echo "    .. Done"

echo "  Bluetooth2"
(time esbmc bluetooth2.cc.c --context-switch 5) > conc_esbmc_logs/bluetooth2.log 2>&1
echo "    .. Done"

echo "  Bluetooth3b"
(time esbmc bluetooth3b.cc.c --context-switch 5) > conc_esbmc_logs/bluetooth3b.log 2>&1
echo "    .. Done"

echo "  Infinite Loop Bug 1"
(time esbmc infloop_bug1.cc.c --unwind 1 --contex-switch 1 --no-unwinding-assertions) > conc_esbmc_logs/infloop_bug1.log 2>&1
echo "    .. Done"

echo "  Infinite Loop Bug 2"
time (esbmc infloop_bug2.cc.c --unwind 2 --context-switch 1 --no-unwinding-assertions) > conc_esbmc_logs/infloop_bug2.log 2>&1
echo "    .. Done"

echo "  Token Ring Bad"
(time esbmc tokenring_bad.cc.c --contex-switch 4) > conc_esbmc_logs/tokenring_bad.log 2>&1
echo "    .. Done"
